// Generated by CoffeeScript 1.3.3
var csv2json, es, merge, parseRow, tidy;

es = require('event-stream');

tidy = function(field) {
  return field != null ? field.trim().replace(/^\"/, '').replace(/\"$/, '').trim() : void 0;
};

merge = function(keys, values) {
  var i, key, output, _i, _len;
  output = {};
  for (i = _i = 0, _len = keys.length; _i < _len; i = ++_i) {
    key = keys[i];
    output[tidy(key)] = tidy(values[i]);
  }
  return output;
};

exports.parseRow = parseRow = function(columns, sep) {
  if (sep == null) {
    sep = ',';
  }
  return es.map(function(data, cb) {
    var record;
    record = merge(columns, data.toString().split(sep));
    return cb(null, JSON.stringify(record));
  });
};

module.exports = csv2json = function(columns, row, col) {
  if (row == null) {
    row = '\n';
  }
  if (col == null) {
    col = ',';
  }
  if (columns == null) {
    throw new Error('columns must be defined.');
  }
  return es.pipe(es.split(row), parseRow(columns, col), es.join(','));
};
